aboutsummaryrefslogtreecommitdiff
diff options
context:
space:
mode:
-rw-r--r--sci-mathematics/petsc/Manifest1
-rw-r--r--sci-mathematics/petsc/petsc-3.10.0.ebuild196
2 files changed, 197 insertions, 0 deletions
diff --git a/sci-mathematics/petsc/Manifest b/sci-mathematics/petsc/Manifest
index 8b6dad87b..4651bddc5 100644
--- a/sci-mathematics/petsc/Manifest
+++ b/sci-mathematics/petsc/Manifest
@@ -1,2 +1,3 @@
+DIST petsc-3.10.0.tar.gz 30850631 BLAKE2B 597f2d428f98b785b13b4819dfffe249401ba630873b75f2f65672126affc0f68b387f67dfd53e8a666e6b7fdeee50de1cf35c4934bcf3afc8053382b4874b0f SHA512 67c657dcbb84d8ede391846d0d79f4f312b770c691438b9909a26cfae119629599079c7f6b60a7ff3766be8335c2cede67ea6368949337fd1c5f12cb4f575aa2
DIST petsc-3.8.4.tar.gz 27946435 BLAKE2B c4d71439695855bce0b6bd46ad434142adc9fd7a0d0b899fa5f02b9fefd65926470db02dfe250376416000031b54c230d338d3085472bad3d61a61b9f30f0713 SHA512 c186e143619c12d2175d01046c26221c462091706af0b68515ba1d2c93f97738ec375df7aa0551c5a14c240e80ca744f9d796778f4937a8c8021d64abe1f3b2c
DIST petsc-3.9.4.tar.gz 29400362 BLAKE2B 702dc05c65805e485713289b66561aaf3fc17131f03c58639f7d676cc026b4143f89ff23c58b196ff0817f1207f379e087992475b4ef5d0eac5a049c4c21448f SHA512 daca9d3ecb9f599988c954ce079f8d6b940f48cef5fcdc56b497e67b1226fc7eb70424eb4696ac90f7b9e75967653967702ce8c7f8b0f906328386697121aa9e
diff --git a/sci-mathematics/petsc/petsc-3.10.0.ebuild b/sci-mathematics/petsc/petsc-3.10.0.ebuild
new file mode 100644
index 000000000..1755e242a
--- /dev/null
+++ b/sci-mathematics/petsc/petsc-3.10.0.ebuild
@@ -0,0 +1,196 @@
+# Copyright 1999-2018 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=6
+
+PYTHON_COMPAT=( python2_7 )
+
+inherit eutils flag-o-matic fortran-2 python-any-r1 toolchain-funcs versionator
+
+MY_P="${PN}-$(replace_version_separator _ -)"
+
+DESCRIPTION="Portable, Extensible Toolkit for Scientific Computation"
+HOMEPAGE="http://www.mcs.anl.gov/petsc/"
+SRC_URI="http://ftp.mcs.anl.gov/pub/petsc/release-snapshots/${MY_P}.tar.gz"
+
+LICENSE="BSD-2"
+SLOT="0"
+KEYWORDS="~x86 ~amd64"
+IUSE="afterimage boost complex-scalars cxx debug doc fftw
+ fortran hdf5 hypre mpi metis mumps scotch sparse superlu threads X"
+
+# hypre and superlu curretly exclude each other due to missing linking to hypre
+# if both are enabled
+REQUIRED_USE="
+ afterimage? ( X )
+ complex-scalars? ( !hypre !superlu )
+ hdf5? ( mpi )
+ hypre? ( cxx mpi !superlu )
+ mumps? ( mpi scotch )
+ scotch? ( mpi )
+ superlu? ( !hypre )
+"
+
+RDEPEND="
+ virtual/blas
+ virtual/lapack
+ afterimage? ( media-libs/libafterimage )
+ boost? ( dev-libs/boost )
+ fftw? ( sci-libs/fftw:3.0[mpi?] )
+ hdf5? ( sci-libs/hdf5[mpi?] )
+ hypre? ( >=sci-libs/hypre-2.8.0b[mpi?] )
+ metis? ( >=sci-libs/parmetis-4 )
+ mpi? ( virtual/mpi[cxx?,fortran?] )
+ mumps? ( sci-libs/mumps[mpi?] sci-libs/scalapack )
+ scotch? ( sci-libs/scotch[mpi?] )
+ sparse? ( sci-libs/suitesparse >=sci-libs/cholmod-1.7.0 )
+ superlu? ( >=sci-libs/superlu-5 )
+ X? ( x11-libs/libX11 )
+"
+
+DEPEND="${RDEPEND}
+ ${PYTHON_DEPS}
+ virtual/pkgconfig
+ dev-util/cmake
+"
+
+S="${WORKDIR}/${MY_P}"
+
+PATCHES=(
+ "${FILESDIR}"/${PN}-3.7.0-disable-rpath.patch \
+ "${FILESDIR}"/${PN}-3.9.0-fix_sandbox_violation.patch
+)
+
+src_prepare() {
+ default
+
+ sed -i -e 's%/usr/bin/env python%/usr/bin/env python2%' configure || die
+}
+
+# petsc uses --with-blah=1 and --with-blah=0 to en/disable options
+petsc_enable() {
+ use "$1" && echo "--with-${2:-$1}=1" || echo "--with-${2:-$1}=0"
+}
+# add external library:
+# petsc_with use_flag libname libdir
+# petsc_with use_flag libname include linking_libs
+petsc_with() {
+ local myuse p=${2:-${1}}
+ if use ${1}; then
+ myuse="--with-${p}=1"
+ if [[ $# -ge 4 ]]; then
+ myuse="${myuse} --with-${p}-include=${EPREFIX}${3}"
+ shift 3
+ myuse="${myuse} --with-${p}-lib=$@"
+ else
+ myuse="${myuse} --with-${p}-dir=${EPREFIX}${3:-/usr}"
+ fi
+ else
+ myuse="--with-${p}=0"
+ fi
+ echo ${myuse}
+}
+
+# select between configure options depending on use flag
+petsc_select() {
+ use "$1" && echo "--with-$2=$3" || echo "--with-$2=$4"
+}
+
+src_configure() {
+ # bug 548498
+ # PETSc runs mpi processes during configure that result in a sandbox
+ # violation by trying to open /proc/mtrr rw. This is not easy to
+ # mitigate because it happens in libpciaccess.so called by libhwloc.so,
+ # which is used by libmpi.so.
+ addpredict /proc/mtrr
+ # if mpi is built with knem support it needs /dev/knem too
+ addpredict /dev/knem
+
+ # configureMPITypes with openmpi-2* insists on accessing the scaling
+ # governor rw.
+ addpredict /sys/devices/system/cpu/
+
+ local mylang
+ local myopt
+
+ use cxx && mylang="cxx" || mylang="c"
+ use debug && myopt="debug" || myopt="opt"
+
+ # environmental variables expected by petsc during build
+
+ export PETSC_DIR="${S}"
+ export PETSC_ARCH="linux-gnu-${mylang}-${myopt}"
+
+ if use debug; then
+ strip-flags
+ filter-flags -O*
+ fi
+
+ # C Support on CXX builds is enabled if possible i.e. when not using
+ # complex scalars (no complex type for both available at the same time)
+
+ econf \
+ scrollOutput=1 \
+ FFLAGS="${FFLAGS} -fPIC" \
+ CFLAGS="${CFLAGS} -fPIC" \
+ CXXFLAGS="${CXXFLAGS} -fPIC" \
+ LDFLAGS="${LDFLAGS}" \
+ --prefix="${EPREFIX}/usr/$(get_libdir)/petsc" \
+ --with-shared-libraries \
+ --with-single-library \
+ --with-clanguage=${mylang} \
+ $(use cxx && ! use complex-scalars && echo "with-c-support=1") \
+ --with-petsc-arch=${PETSC_ARCH} \
+ --with-precision=double \
+ --with-gnu-compilers \
+ --with-blas-lapack-lib="$($(tc-getPKG_CONFIG) --libs lapack)" \
+ $(petsc_enable debug debugging) \
+ $(petsc_enable mpi) \
+ $(petsc_select mpi cc mpicc $(tc-getCC)) \
+ $(petsc_select mpi cxx mpicxx $(tc-getCXX)) \
+ $(petsc_enable fortran) \
+ $(use fortran && echo "$(petsc_select mpi fc mpif77 $(tc-getF77))") \
+ $(petsc_enable mpi mpi-compilers) \
+ $(petsc_select complex-scalars scalar-type complex real) \
+ --with-windows-graphics=0 \
+ --with-matlab=0 \
+ --with-cmake=cmake \
+ $(petsc_enable threads pthread) \
+ $(petsc_with afterimage afterimage \
+ /usr/include/libAfterImage -lAfterImage) \
+ $(petsc_with hdf5) \
+ $(petsc_with hypre hypre \
+ /usr/include/hypre -lHYPRE) \
+ $(petsc_with sparse suitesparse) \
+ $(petsc_with superlu superlu \
+ /usr/include/superlu -lsuperlu) \
+ $(petsc_with X x) \
+ $(petsc_with X x11) \
+ $(petsc_with scotch ptscotch \
+ /usr/include/scotch \
+ [-lptesmumps,-lptscotch,-lptscotcherr,-lscotch,-lscotcherr]) \
+ $(petsc_with mumps scalapack \
+ /usr/include/scalapack -lscalapack) \
+ $(petsc_with mumps mumps \
+ /usr/include \
+ [-lcmumps,-ldmumps,-lsmumps,-lzmumps,-lmumps_common,-lpord]) \
+ --with-imagemagick=0 \
+ --with-python=0 \
+ $(petsc_with boost) \
+ $(petsc_with fftw)
+}
+
+src_install() {
+ emake DESTDIR="${ED}" install
+
+ # add PETSC_DIR to environmental variables
+ cat >> 99petsc <<- EOF
+ PETSC_DIR=${EPREFIX}/usr/$(get_libdir)/petsc
+ EOF
+ doenvd 99petsc
+
+ if use doc ; then
+ dodoc docs/developers.pdf docs/manual.pdf
+ dohtml -r docs/*.html docs/changes docs/manualpages
+ fi
+}